
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import com.java4less.raztec.*;

//  RAztec Code
//  Copyright (C)
//
//  Java4Less@Confluencia.net
//  All rights reserved
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material
//  - You may not copy and paste any code into external files.

public class AztecCodeDemo extends JFrame {
  AztecCode barcode = new AztecCode();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton btnApply = new JButton();
  JButton btnPrint = new JButton();
  JButton btnSave = new JButton();
  JButton btnExit = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField txtValue = new JTextField();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JLabel jLabel8 = new JLabel();
  JCheckBox chkStructuredAppend = new JCheckBox();
  JLabel jLabel9 = new JLabel();
  JLabel jLabel10 = new JLabel();
  JLabel jLabel11 = new JLabel();
  JTextField txtFileID = new JTextField();
  JTextField txtIndex = new JTextField();
  JTextField txtTotal = new JTextField();
  JComboBox cEncoding = new JComboBox();
  JComboBox cType = new JComboBox();
  JComboBox cFormat = new JComboBox();
  JTextField txtEC = new JTextField();
  JTextField txtRune = new JTextField();
  JTextField txtMargin = new JTextField();
  JTextField txtModuleSize = new JTextField();
  JLabel jLabel13 = new JLabel();
  JComboBox cResolution = new JComboBox();

  public static void main(String[] args) {

  //byte[] b={(byte) 0xF1,(byte) 0xF2,(byte) 0xF3,(byte) 0xF4,(byte) 0xF5,(byte) 0xF6,(byte) 0xF7,(byte) 0xF8,(byte) 0xF9};
  //System.out.println(new String(b));

    AztecCodeDemo f=new AztecCodeDemo();
    f.setSize(410,515);
    f.setLocation(100,100);
    f.show();
  }

  public AztecCodeDemo() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(null);
    barcode.setBounds(new Rectangle(3, 5, 395, 194));
    jTabbedPane1.setBounds(new Rectangle(4, 206, 393, 228));
    btnApply.setText("Apply");
    btnApply.setBounds(new Rectangle(23, 446, 79, 27));
    btnApply.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnApply_actionPerformed(e);
      }
    });
    btnPrint.setText("Print");
    btnPrint.setBounds(new Rectangle(111, 446, 79, 27));
    btnPrint.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnPrint_actionPerformed(e);
      }
    });
    btnSave.setBounds(new Rectangle(200, 446, 79, 27));
    btnSave.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnSave_actionPerformed(e);
      }
    });
    btnSave.setText("Save");
    btnExit.setBounds(new Rectangle(291, 446, 79, 27));
    btnExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExit_actionPerformed(e);
      }
    });
    btnExit.setText("Exit");
    jLabel1.setText("Value");
    jLabel1.setBounds(new Rectangle(10, 21, 48, 17));
    jPanel2.setLayout(null);
    txtValue.setText("This is a aztec code");
    txtValue.setBounds(new Rectangle(55, 20, 316, 21));
    jLabel2.setText("Encoding");
    jLabel2.setBounds(new Rectangle(8, 52, 64, 17));
    jLabel3.setText("Type");
    jLabel3.setBounds(new Rectangle(8, 79, 63, 17));
    jLabel4.setText("Format");
    jLabel4.setBounds(new Rectangle(8, 106, 41, 17));
    jLabel5.setText("Module size");
    jLabel5.setBounds(new Rectangle(8, 136, 76, 17));
    jLabel6.setText("Correction level");
    jLabel6.setBounds(new Rectangle(208, 56, 91, 17));
    jLabel7.setText("Rune (0-255)");
    jLabel7.setBounds(new Rectangle(208, 80, 95, 17));
    jLabel8.setText("Margin");
    jLabel8.setBounds(new Rectangle(208, 109, 41, 17));
    jPanel3.setLayout(null);
    chkStructuredAppend.setText("Enable structured append");
    chkStructuredAppend.setBounds(new Rectangle(21, 15, 223, 25));
    jLabel9.setText("File Id");
    jLabel9.setBounds(new Rectangle(19, 47, 49, 17));
    jLabel10.setText("Index");
    jLabel10.setBounds(new Rectangle(19, 78, 48, 17));
    jLabel11.setText("Total");
    jLabel11.setBounds(new Rectangle(19, 103, 48, 17));
    txtFileID.setBounds(new Rectangle(69, 45, 280, 21));
    txtIndex.setText("0");
    txtIndex.setBounds(new Rectangle(69, 75, 63, 21));
    txtTotal.setText("1");
    txtTotal.setBounds(new Rectangle(69, 102, 63, 21));
    cEncoding.setBounds(new Rectangle(75, 51, 126, 21));
    cType.setBounds(new Rectangle(76, 79, 125, 21));
    cFormat.setBounds(new Rectangle(76, 108, 125, 21));
    txtEC.setText("23");
    txtEC.setBounds(new Rectangle(308, 51, 63, 21));
    txtRune.setText("-1");
    txtRune.setBounds(new Rectangle(310, 78, 63, 21));
    txtMargin.setText("30");
    txtMargin.setBounds(new Rectangle(309, 105, 63, 21));
    txtModuleSize.setText("4");
    txtModuleSize.setBounds(new Rectangle(123, 134, 78, 21));
    jLabel13.setBounds(new Rectangle(8, 152, 119, 17));
    jLabel13.setText("Printer Resolution");
    cResolution.setBounds(new Rectangle(128, 151, 85, 21));
    cResolution.setBounds(new Rectangle(123, 164, 79, 21));
    jLabel13.setText("Printer Resolution");
    jLabel13.setBounds(new Rectangle(9, 165, 112, 17));
    this.setTitle("Aztec Code demo");
    this.getContentPane().add(jTabbedPane1, null);
    jTabbedPane1.add(jPanel2, "Aztec");
    jPanel2.add(jLabel1, null);
    jPanel2.add(txtValue, null);
    jPanel2.add(txtEC, null);
    jPanel2.add(jLabel2, null);
    jPanel2.add(jLabel3, null);
    jPanel2.add(jLabel4, null);
    jPanel2.add(jLabel5, null);
    jPanel2.add(txtModuleSize, null);
    jPanel2.add(cFormat, null);
    jPanel2.add(cType, null);
    jPanel2.add(cEncoding, null);
    jPanel2.add(jLabel6, null);
    jPanel2.add(jLabel7, null);
    jPanel2.add(jLabel8, null);
    jPanel2.add(txtMargin, null);
    jPanel2.add(txtRune, null);
    jPanel2.add(cResolution, null);
    jPanel2.add(jLabel13, null);
    jTabbedPane1.add(jPanel3, "Structured Append");
    jPanel3.add(chkStructuredAppend, null);
    jPanel3.add(jLabel9, null);
    jPanel3.add(txtFileID, null);
    jPanel3.add(txtIndex, null);
    jPanel3.add(txtTotal, null);
    jPanel3.add(jLabel11, null);
    jPanel3.add(jLabel10, null);

    this.getContentPane().add(barcode, null);
    this.getContentPane().add(btnExit, null);
    this.getContentPane().add(btnSave, null);
    this.getContentPane().add(btnPrint, null);
    this.getContentPane().add(btnApply, null);

    this.cEncoding.addItem("NORMAL");
    this.cEncoding.addItem("BINARY");

    this.cType.addItem("ANY");
    this.cType.addItem("COMPACT");
    this.cType.addItem("FULL RANGE");

    this.cResolution.addItem("72 dpi (default)");
    this.cResolution.addItem("300 dpi");
    this.cResolution.addItem("600 dpi");

this.cFormat.addItem("15X15_COMPACT");
this.cFormat.addItem("19X19");
this.cFormat.addItem("19X19_COMPACT");
this.cFormat.addItem("23X23");
this.cFormat.addItem("23X23_COMPACT");
this.cFormat.addItem("27X27");
this.cFormat.addItem("27X27_COMPACT");
this.cFormat.addItem("31X31");
this.cFormat.addItem("37X37");
this.cFormat.addItem("41X41");
this.cFormat.addItem("45X45");
this.cFormat.addItem("49X49");
this.cFormat.addItem("53X53");
this.cFormat.addItem("57X57");
this.cFormat.addItem("61X61");
this.cFormat.addItem("67X67");
this.cFormat.addItem("71X71");
this.cFormat.addItem("75X75");
this.cFormat.addItem("79X79");
this.cFormat.addItem("83X83");
this.cFormat.addItem("87X87");
this.cFormat.addItem("91X91");
this.cFormat.addItem("95X95");
this.cFormat.addItem("101X101");
this.cFormat.addItem("105X105");
this.cFormat.addItem("109X109");
this.cFormat.addItem("113X113");
this.cFormat.addItem("117X117");
this.cFormat.addItem("121X121");
this.cFormat.addItem("125X125");
this.cFormat.addItem("131X131");
this.cFormat.addItem("135X135");
this.cFormat.addItem("139X139");
this.cFormat.addItem("143X143");
this.cFormat.addItem("147X147");
this.cFormat.addItem("151X151");

  }

  public void show() {
    super.show();
    btnApply_actionPerformed(null);
  }

  void btnApply_actionPerformed(ActionEvent e) {

  barcode.setProcessTilde(true);

  barcode.setCode(this.txtValue.getText());

  barcode.setEncoding(barcode.ENC_NORMAL);
  if (this.cEncoding.getSelectedIndex()>=0)  barcode.setEncoding(this.cEncoding.getSelectedIndex());

  barcode.setPreferredConfiguration(barcode.CONFIGURATION_15X15_COMPACT);
  if (this.cFormat.getSelectedIndex()>=0) barcode.setPreferredConfiguration(this.cFormat.getSelectedIndex());

  barcode.setConfigurationType(barcode.CONFIGURATION_ANY);
  if (this.cType.getSelectedIndex()>=0) barcode.setConfigurationType(this.cType.getSelectedIndex());

  barcode.setFileId(this.txtFileID.getText());
//  if (this.) barcode.setsetFileId(this.txtFileID.getText());

  if (this.chkStructuredAppend.isSelected()) barcode.setStructuredAppend(true);
  else barcode.setStructuredAppend(false);

try {

    barcode.setModuleSize(Integer.parseInt(this.txtModuleSize.getText()));
    barcode.setMargin(Integer.parseInt(this.txtMargin.getText()));
    barcode.setErrorCorrectionLevel(Integer.parseInt(this.txtEC.getText()));
    barcode.setStructuredAppendCounter(Integer.parseInt(this.txtTotal.getText()));
    barcode.setStructuredAppendIndex(Integer.parseInt(this.txtIndex.getText()));

    if (txtRune.getText().length()==0) txtRune.setText("-1");
    barcode.setRune(Integer.parseInt(this.txtRune.getText()));

    }
    catch (Exception ex) {}

    this.paintAll(this.getGraphics());
    this.repaint();
    barcode.setRedraw(true);
    barcode.paint(barcode.getGraphics());

  }

  void btnPrint_actionPerformed(ActionEvent e) {

   // set printer resolution
    java.awt.PageAttributes pa= new PageAttributes();

    if (this.cResolution.getSelectedIndex()==1) pa.setPrinterResolution(300);
    if (this.cResolution.getSelectedIndex()==2) pa.setPrinterResolution(600);
    //pa.setPrinterResolution(barcode.getResolution());

    // get printer job
    java.awt.PrintJob pj=Toolkit.getDefaultToolkit().getPrintJob(this,"AztecCode",null,pa);

    barcode.setRedraw(true);

    java.awt.image.BufferedImage im=new java.awt.image.BufferedImage(barcode.getWidth(),barcode.getHeight(),java.awt.image.BufferedImage.TYPE_INT_RGB);
    Graphics g2=im.createGraphics();
    barcode.paint(g2);

    //    print barcode
    Graphics g= pj.getGraphics();

     g.drawImage(im,pj.getPageDimension().width/2,pj.getPageDimension().height/3,null);
    // end job
    pj.end();

  }

  void btnSave_actionPerformed(ActionEvent e) {

    FileDialog f=new FileDialog(this,"Select JPG File",FileDialog.SAVE);

     f.show();

     if (f.getFile()!=null) {
         barcode.setSize(barcode.getPreferredSize());
         //barcode.setSize(600,600);
         String fi=f.getDirectory()+f.getFile();
         if (!fi.toUpperCase().endsWith("JPG")) fi=fi+".jpg";
         System.out.println(fi);
         com.java4less.encoder.ImageEncoder   be=  new com.java4less.encoder.ImageEncoder(barcode,"JPEG",fi);

         javax.swing.JOptionPane.showMessageDialog(this,"The JPEG file has been saved. We recommend you to use GIF or PNG formats for scanning purposes. See Documentation.");
       }
  }

  void btnExit_actionPerformed(ActionEvent e) {
      System.exit(0);
  }

}
