
//  RAztec
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reservedse
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - You may not copy and paste any code into external files.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material

import com.java4less.raztec.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;

	public class RAztecServlet  extends HttpServlet
    {


  public static void main(String[] a) {

  }


         private boolean debug=false;

        /**
         * Handle the HTTP POST method by sending an e-mail
         *
         *
         */

	    public void init() throws ServletException  {

	    }

       // read paramters form request an create barcode
       // http://localhost:8080/examples/servlet/RAztecServlet?DATA=AAADDEEE...
       public AztecCode getBarcode (HttpServletRequest request) {

       	  AztecCode cb=new AztecCode();

          if (request==null) return cb;

            if (request.getParameter("DEBUG")!=null)
               if (request.getParameter("DEBUG").toUpperCase().compareTo("ON")==0) debug =true;

          // READ DATA
          String dataStr=request.getParameter("DATA");
          if (dataStr!=null) cb.setCode(dataStr);

          String mode=request.getParameter("PROCESSTILDE");
          if (mode!=null) {
             if (mode.compareTo("Y")==0) cb.setProcessTilde(true);
          }

          mode=request.getParameter("ENCODING");
          cb.setEncoding(AztecCode.ENC_NORMAL);
          if (mode!=null) {
             if (mode.compareTo("BINARY")==0) cb.setEncoding(AztecCode.ENC_BINARY);
          }

          String ec=request.getParameter("ERROR_CORRECTION");
          if (ec!=null)
             cb.setErrorCorrectionLevel(Integer.parseInt(ec));

          String ir=request.getParameter("INIT_READER");
          if (ir!=null)
             cb.setReaderInitilization(ir.equals("Y"));

          String ms=request.getParameter("MODULE_SIZE");
          if (ms!=null)
             cb.setModuleSize(Integer.parseInt(ms));

          String ma=request.getParameter("MARGIN");
          if (ma!=null)
             cb.setMargin(Integer.parseInt(ma));

          ma=request.getParameter("RUNE");
          if (ma!=null)
             cb.setRune(Integer.parseInt(ma));


          ma=request.getParameter("TYPE");
          if (ma!=null) {
            if (ma.equalsIgnoreCase("ANY")) cb.setConfigurationType(AztecCode.CONFIGURATION_ANY);
            if (ma.equalsIgnoreCase("COMPACT")) cb.setConfigurationType(AztecCode.CONFIGURATION_COMPACT);
            if (ma.equalsIgnoreCase("FULL")) cb.setConfigurationType(AztecCode.CONFIGURATION_FULL);
          }

          String preferredConf=request.getParameter("CONFIGURATION");
          if (preferredConf!=null) {
            if (preferredConf.compareTo("CONFIGURATION_15X15_COMPACT")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_15X15_COMPACT);
            if (preferredConf.compareTo("CONFIGURATION_19X19")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_19X19);
            if (preferredConf.compareTo("CONFIGURATION_19X19_COMPACT")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_19X19_COMPACT);
            if (preferredConf.compareTo("CONFIGURATION_23X23")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_23X23);
            if (preferredConf.compareTo("CONFIGURATION_23X23_COMPACT")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_23X23_COMPACT);
            if (preferredConf.compareTo("CONFIGURATION_27X27")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_27X27);
            if (preferredConf.compareTo("CONFIGURATION_27X27_COMPACT")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_27X27_COMPACT);
            if (preferredConf.compareTo("CONFIGURATION_31X31")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_31X31);
            if (preferredConf.compareTo("CONFIGURATION_37X37")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_37X37);
            if (preferredConf.compareTo("CONFIGURATION_41X41")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_41X41);
            if (preferredConf.compareTo("CONFIGURATION_45X45")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_45X45);
            if (preferredConf.compareTo("CONFIGURATION_49X49")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_49X49);
            if (preferredConf.compareTo("CONFIGURATION_53X53")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_53X53);
            if (preferredConf.compareTo("CONFIGURATION_57X57")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_57X57);
            if (preferredConf.compareTo("CONFIGURATION_61X61")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_61X61);
            if (preferredConf.compareTo("CONFIGURATION_67X67")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_67X67);
            if (preferredConf.compareTo("CONFIGURATION_71X71")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_71X71);
            if (preferredConf.compareTo("CONFIGURATION_75X75")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_75X75);
            if (preferredConf.compareTo("CONFIGURATION_79X79")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_79X79);
            if (preferredConf.compareTo("CONFIGURATION_83X83")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_83X83);
            if (preferredConf.compareTo("CONFIGURATION_87X87")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_87X87);
            if (preferredConf.compareTo("CONFIGURATION_91X91")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_91X91);
            if (preferredConf.compareTo("CONFIGURATION_95X95")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_95X95);
            if (preferredConf.compareTo("CONFIGURATION_101X101")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_101X101);
            if (preferredConf.compareTo("CONFIGURATION_105X105")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_105X105);
            if (preferredConf.compareTo("CONFIGURATION_109X109")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_109X109);
            if (preferredConf.compareTo("CONFIGURATION_113X113")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_113X113);
            if (preferredConf.compareTo("CONFIGURATION_117X117")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_117X117);
            if (preferredConf.compareTo("CONFIGURATION_121X121")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_121X121);
            if (preferredConf.compareTo("CONFIGURATION_125X125")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_125X125);
            if (preferredConf.compareTo("CONFIGURATION_131X131")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_131X131);
            if (preferredConf.compareTo("CONFIGURATION_135X135")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_135X135);
            if (preferredConf.compareTo("CONFIGURATION_139X139")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_139X139);
            if (preferredConf.compareTo("CONFIGURATION_143X143")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_143X143);
            if (preferredConf.compareTo("CONFIGURATION_147X147")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_147X147);
            if (preferredConf.compareTo("CONFIGURATION_151X151")==0) cb.setPreferredConfiguration(cb.CONFIGURATION_151X151);
          }

          return cb;


       }

       // Handle a request
       // 1. create barcode
       // 2. draw barcode in a Buffered Image
       // 3. encode image as GIF or JPEG and send it to the browser
        public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException
        {

               PrintWriter		out;
               ServletOutputStream outb;

              String encode="jpeg";

               if (request!=null) {
                 if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();

                 if ((encode.toLowerCase().compareTo("gif")!=0) && ((encode.toLowerCase().compareTo("png")!=0))) encode="jpeg";
               }

               response.setContentType("image/"+encode);

		//out=response.getWriter();
		outb=response.getOutputStream();

                // avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);

               try { // Create buffer


               int w=400;
               int h=200;


               if (request!=null) {
                 if (request.getParameter("WIDTH")!=null) w=new Integer(request.getParameter("WIDTH")).intValue();
                 if (request.getParameter("HEIGHT")!=null) h=new Integer(request.getParameter("HEIGHT")).intValue();
               }

		java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
		java.awt.Graphics2D BarGraphics=BarImage.createGraphics();

                // get BarCode
                AztecCode cb=getBarcode(request);

                 if (debug) System.out.println("Size: "+w+" "+h);
                cb.setSize(w,h);

                cb.paint(BarGraphics);

               if (encode.toLowerCase().compareTo("gif")==0) {
                 // download gif encoder from http://www.acme.com/resources/classes/Acme.tar.gz
                 // encode buffered image to a gif

                   Class enClass=Class.forName("Acme.JPM.Encoders.GifEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encode",encodeParams).invoke(encoder,encodeObj);

                 // Acme.JPM.Encoders.GifEncoder encoder = new Acme.JPM.Encoders.GifEncoder(BarImage  ,outb);
                 // encoder.encode();
                }
                else
                if (encode.toLowerCase().compareTo("png")==0) {
                    // download from http://users.boone.net/wbrameld/pngencoder/

                  Class enClass=Class.forName("com.bigfoot.bugar.image.PNGEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encodeImage",encodeParams).invoke(encoder,encodeObj);


                    //com.bigfoot.bugar.image.PNGEncoder en= new com.bigfoot.bugar.image.PNGEncoder(BarImage  ,outb);
                    //en.encodeImage();
                }
                else {
                  // create JPEG image
                  com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                  encoder.encode( BarImage );
                }

              } catch (Exception e) { e.printStackTrace();}

	}


        public void doPost (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException
        {
        try {
            doGet(request,response);
            } catch (Exception e) { e.printStackTrace();}
	}

    }


